/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_PROXY_BASE_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_PROXY_BASE_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadio.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesProxyBase.hpp>


#include <v1/commonapi/telux/common/CommonDefines.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypes.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <cstdint>
#include <vector>

#include <CommonAPI/Event.hpp>
#include <CommonAPI/Proxy.hpp>
#include <functional>
#include <future>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

class Cv2xRadioProxyBase
    : virtual public ::v1::commonapi::telux::cv2x::Cv2xRadioTypesProxyBase {
public:
    typedef CommonAPI::Event<
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus
    > CurrentCv2xStatusEvent;
    typedef CommonAPI::Event<
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx
    > CurrentCv2xStatusExEvent;
    typedef CommonAPI::Event<
        uint32_t
    > CurrentL2AddrEvent;
    typedef CommonAPI::Event<
        int32_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails
    > CurrentSpsOffsetEvent;
    typedef CommonAPI::Event<
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities
    > CurrentCapabilitiesEvent;
    typedef CommonAPI::Event<
        bool
    > MacAddrCloneEvent;

    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const uint32_t&)> CreateRxSubscriptionAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::common::CommonDefines::ServiceStatus&)> GetServiceStatusAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&)> EnableRxMetaDataReportAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const uint32_t&, const uint32_t&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&)> CreateTxSpsFlowAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const uint32_t&)> CreateTxEventFlowAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&)> CloseRxSubscriptionAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&)> CloseTxFlowAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&)> ChangeSpsFlowInfoAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo&)> RequestSpsFlowInfoAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&)> ChangeEventFlowInfoAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities&)> RequestCapabilityAsyncCallback;

    virtual void createRxSubscription(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint16_t _port, std::vector< uint32_t > _idList, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_subscriptionId, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> createRxSubscriptionAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const uint16_t &_port, const std::vector< uint32_t > &_idList, CreateRxSubscriptionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void getServiceStatus(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus &_status, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> getServiceStatusAsync(GetServiceStatusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void enableRxMetaDataReport(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, bool _enable, std::vector< uint32_t > _idList, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> enableRxMetaDataReportAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const bool &_enable, const std::vector< uint32_t > &_idList, EnableRxMetaDataReportAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void createTxSpsFlow(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, uint16_t _spsSrcPort, bool _eventSrcPortValid, uint16_t _eventSrcPort, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_txSpsFlowId, uint32_t &_txEventFlowId, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_spsError, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_eventError, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> createTxSpsFlowAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipType, const uint32_t &_serviceId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, const uint16_t &_spsSrcPort, const bool &_eventSrcPortValid, const uint16_t &_eventSrcPort, CreateTxSpsFlowAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void createTxEventFlow(::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipTyp, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _flowInfo, uint16_t _eventSrcPort, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, uint32_t &_txEventFlowId, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> createTxEventFlowAsync(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType &_ipTyp, const uint32_t &_serviceId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo &_flowInfo, const uint16_t &_eventSrcPort, CreateTxEventFlowAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void closeRxSubscription(uint32_t _subscriptionId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> closeRxSubscriptionAsync(const uint32_t &_subscriptionId, CloseRxSubscriptionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void closeTxFlow(uint32_t _txFlowId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> closeTxFlowAsync(const uint32_t &_txFlowId, CloseTxFlowAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void changeSpsFlowInfo(uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> changeSpsFlowInfoAsync(const uint32_t &_txFlowId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, ChangeSpsFlowInfoAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void requestSpsFlowInfo(uint32_t _txFlowId, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo &_spsInfo, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> requestSpsFlowInfoAsync(const uint32_t &_txFlowId, RequestSpsFlowInfoAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void changeEventFlowInfo(uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _eventInfo, CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> changeEventFlowInfoAsync(const uint32_t &_txFlowId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo &_eventInfo, ChangeEventFlowInfoAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void requestCapability(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> requestCapabilityAsync(RequestCapabilityAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual CurrentCv2xStatusEvent& getCurrentCv2xStatusEvent() = 0;
    virtual CurrentCv2xStatusExEvent& getCurrentCv2xStatusExEvent() = 0;
    virtual CurrentL2AddrEvent& getCurrentL2AddrEvent() = 0;
    virtual CurrentSpsOffsetEvent& getCurrentSpsOffsetEvent() = 0;
    virtual CurrentCapabilitiesEvent& getCurrentCapabilitiesEvent() = 0;
    virtual MacAddrCloneEvent& getMacAddrCloneEvent() = 0;

    virtual std::future<void> getCompletionFuture() = 0;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_PROXY_BASE_HPP_
